import usb
import random
import time
portb = 0
portc = 1
s_off = 0
s_on = 1
rnd = 1
per_t = 180
req_in = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
req_out = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT

def find_board():
    board = None
    for bus in usb.busses():
        for dev in bus.devices:
            if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                return dev
    return None
def set_led(led_no,port,status):
	board = find_board()
	handle = board.open()
	if(port==portc):
		if(status==0):
			handle.controlMsg(req_out, 0, None, value=led_no)
		else:
			handle.controlMsg(req_out, 0, None, value=256+led_no)
	else:
		if(status==0):
			handle.controlMsg(req_out, 4, None, value=led_no)
		else:
			handle.controlMsg(req_out, 4, None, value=256+led_no)
def get_light(light_no):
	board = find_board()
	handle = board.open()
	if(light_no==0):
		res = handle.controlMsg(req_in, 5, 2)
		sum = res[0]+res[1]*256
	elif(light_no==1):
		res = handle.controlMsg(req_in, 6, 2)
		sum = res[0]+res[1]*256
	else :
		res = handle.controlMsg(req_in, 7, 2)
		sum = res[0]+res[1]*256
	return sum
def off_all():
	set_led(1,portc,s_off)
	set_led(0,portc,s_off)
	set_led(3,portc,s_off)
def on_all():
	set_led(1,portc,s_on)
	set_led(0,portc,s_on)
	set_led(3,portc,s_on)
def init():
	board = find_board()
	handle = board.open()
	tmp=0
	tmp = tmp + get_light(0)
	tmp = tmp + get_light(1)
	tmp = tmp + get_light(2)
	tmp = tmp / 3
	set_led(1,portc,s_on)
	set_led(0,portc,s_on)
	set_led(3,portc,s_on)
	time.sleep(1)
	set_led(1,portc,s_off)
	set_led(0,portc,s_off)
	set_led(3,portc,s_off)
	time.sleep(0.5)
	set_led(1,portc,s_on)
	set_led(3,portc,s_on)
	time.sleep(1)
	set_led(1,portc,s_off)
	set_led(3,portc,s_off)
	time.sleep(0.5)
	set_led(0,portc,s_on)
	time.sleep(1)
	set_led(0,portc,s_off)
	time.sleep(0.5)
	set_led(1,portc,s_on)
	set_led(0,portc,s_on)
	set_led(3,portc,s_on)
	time.sleep(1)
	set_led(1,portc,s_off)
	set_led(0,portc,s_off)
	set_led(3,portc,s_off)
	return tmp
def get_order(mx):
	order = []
	i=0
	while i < mx :
		tmp = random.randint(0,2)
		if tmp == 2:
			order.append(3)
		else:
			order.append(tmp)
		i=i+1
	return order
def is_push(light_no,ref):
	if(get_light(light_no)<ref):
		return 1
	else:
		return 0
def led_play(order,mx,ref):
	score = 0
	for e in order :
		if e == 1 : light_no = 0
		elif e == 0 : light_no = 1
		else : light_no =2
		is_p = 0
		p0=0
		p1=0
		p2=0
		i=0
		while is_p ==0 and i < per_t:
			is_p = is_push(light_no,ref)
			i=i+1
		#print str(p0) + " " + str(p1) + " " + str(p2) + " " + str(is_p)
		#if(p0+p1+p2+is_p==2):
		if is_p == 1 :
			set_led(e,portc,s_on)
			score = score + 1
			time.sleep(0.5)
			set_led(e,portc,s_off)
	if score == mx :
		set_led(2,portb,s_on)
	elif score == 0 :
		set_led(0,portb,s_on)
	else :
		set_led(1,portb,s_on)
	time.sleep(1)
	set_led(0,portb,s_off)
	set_led(1,portb,s_off)
	set_led(2,portb,s_off)
	return score
def led_start(mx,ref):
	order = get_order(mx)
	for e in order:
		off_all()
		time.sleep(0.3)
		set_led(e,portc,s_on)
		time.sleep(0.5)
		set_led(e,portc,s_off)
	on_all()
	time.sleep(1)
	off_all()
	score = led_play(order,mx,ref)
	return score
def game_start():
	ref = init() - 300
	print ref
	i=3
	loose = False
	sum_score = 0
	while not loose:
		off_all();
		time.sleep(0.5)
		loose = False
		score = led_start(i,ref)
		sum_score = sum_score + score
		if score != i :
			loose = True
		i=i+1
	return sum_score
print "Your Score is : " + str(game_start())
